diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lr-wpan/model/lr-wpan-mac.cc ns-3.34/src/lr-wpan/model/lr-wpan-mac.cc
--- ns-3.33/src/lr-wpan/model/lr-wpan-mac.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lr-wpan/model/lr-wpan-mac.cc	2021-07-14 10:31:06.000000000 -0700
@@ -140,6 +140,11 @@
                      "the sent packet",
                      MakeTraceSourceAccessor (&LrWpanMac::m_sentPktTrace),
                      "ns3::LrWpanMac::SentTracedCallback")
+    .AddTraceSource ("IfsEnd",
+                     "Trace source reporting the end of an "
+                     "Interframe space (IFS) ",
+                     MakeTraceSourceAccessor (&LrWpanMac::m_macIfsEndTrace),
+                     "ns3::Packet::TracedCallback")
   ;
   return tid;
 }
@@ -390,7 +395,7 @@
         {
           // short address and ACK requested.
           Mac16Address shortAddr = macHdr.GetShortDstAddr ();
-          if (shortAddr.IsBroadcast() || shortAddr.IsMulticast())
+          if (shortAddr.IsBroadcast () || shortAddr.IsMulticast ())
             {
               NS_LOG_LOGIC ("LrWpanMac::McpsDataRequest: requested an ACK on broadcast or multicast destination (" << shortAddr << ") - forcefully removing it.");
               macHdr.SetNoAckReq ();
@@ -899,9 +904,13 @@
       //TODO: this should check if the node is a coordinator and using the outcoming superframe not just the PAN coordinator
       if (m_csmaCa->IsUnSlottedCsmaCa () || (m_outSuperframeStatus == CAP && m_panCoor) || m_incSuperframeStatus == CAP)
         {
-          TxQueueElement *txQElement = m_txQueue.front ();
-          m_txPkt = txQElement->txQPkt;
-          m_setMacState = Simulator::ScheduleNow (&LrWpanMac::SetLrWpanMacState, this, MAC_CSMA);
+          // check MAC is not in a IFS
+          if (!m_ifsEvent.IsRunning ())
+            {
+              TxQueueElement *txQElement = m_txQueue.front ();
+              m_txPkt = txQElement->txQPkt;
+              m_setMacState = Simulator::ScheduleNow (&LrWpanMac::SetLrWpanMacState, this, MAC_CSMA);
+            }
         }
     }
 }
@@ -1362,9 +1371,10 @@
                           m_mcpsDataConfirmCallback (confirmParams);
                         }
                       RemoveFirstTxQElement ();
-
+                      m_setMacState.Cancel ();
+                      m_setMacState = Simulator::ScheduleNow (&LrWpanMac::SetLrWpanMacState, this, MAC_IDLE);
                       // Ack was succesfully received, wait for the Interframe Space (IFS) and then proceed
-                      m_ifsEvent = Simulator::Schedule (ifsWaitTime, &LrWpanMac::IfsWaitTimeout, this);
+                      m_ifsEvent = Simulator::Schedule (ifsWaitTime, &LrWpanMac::IfsWaitTimeout, this, ifsWaitTime);
                     }
                   else
                     {
@@ -1433,7 +1443,7 @@
   Ptr<Packet> pkt = p->Copy ();
   LrWpanMacHeader hdr;
   pkt->RemoveHeader (hdr);
-  if (!hdr.GetShortDstAddr ().IsBroadcast () && !hdr.GetShortDstAddr ().IsMulticast())
+  if (!hdr.GetShortDstAddr ().IsBroadcast () && !hdr.GetShortDstAddr ().IsMulticast ())
     {
       m_sentPktTrace (p, m_retransmission + 1, m_numCsmacaRetry);
     }
@@ -1466,11 +1476,27 @@
 }
 
 void
-LrWpanMac::IfsWaitTimeout (void)
+LrWpanMac::IfsWaitTimeout (Time ifsTime)
 {
-  NS_LOG_DEBUG ("IFS Completed");
-  m_setMacState.Cancel ();
-  m_setMacState = Simulator::ScheduleNow (&LrWpanMac::SetLrWpanMacState, this, MAC_IDLE);
+  uint64_t symbolRate = (uint64_t) m_phy->GetDataOrSymbolRate (false);
+  Time lifsTime = Seconds ((double) m_macLIFSPeriod / symbolRate);
+  Time sifsTime = Seconds ((double) m_macSIFSPeriod / symbolRate);
+
+  if (ifsTime == lifsTime)
+    {
+      NS_LOG_DEBUG ("LIFS of " << m_macLIFSPeriod << " symbols (" << ifsTime.As (Time::S) << ") completed ");
+    }
+  else if (ifsTime == sifsTime)
+    {
+      NS_LOG_DEBUG ("SIFS of " << m_macSIFSPeriod << " symbols (" << ifsTime.As (Time::S) << ") completed ");
+    }
+  else
+    {
+      NS_LOG_DEBUG ("Unknown IFS size (" << ifsTime.As (Time::S) << ") completed ");
+    }
+
+  m_macIfsEndTrace (ifsTime);
+  CheckQueue ();
 }
 
 
@@ -1612,14 +1638,13 @@
 
   if (!ifsWaitTime.IsZero ())
     {
-      m_ifsEvent = Simulator::Schedule (ifsWaitTime, &LrWpanMac::IfsWaitTimeout, this);
-    }
-  else
-    {
-      m_setMacState.Cancel ();
-      m_setMacState = Simulator::ScheduleNow (&LrWpanMac::SetLrWpanMacState, this, MAC_IDLE);
+      m_ifsEvent = Simulator::Schedule (ifsWaitTime, &LrWpanMac::IfsWaitTimeout, this, ifsWaitTime);
     }
 
+  m_setMacState.Cancel ();
+  m_setMacState = Simulator::ScheduleNow (&LrWpanMac::SetLrWpanMacState, this, MAC_IDLE);
+
+
 }
 
 void
@@ -1668,7 +1693,13 @@
   else if (m_lrWpanMacState == MAC_IDLE)
     {
       NS_ASSERT (status == IEEE_802_15_4_PHY_RX_ON || status == IEEE_802_15_4_PHY_SUCCESS || status == IEEE_802_15_4_PHY_TRX_OFF);
-      // Do nothing special when going idle.
+
+      if (status == IEEE_802_15_4_PHY_RX_ON || status == IEEE_802_15_4_PHY_SUCCESS)
+        {
+          // Check if there is not messages to transmit when going idle
+          CheckQueue ();
+        }
+
     }
   else if (m_lrWpanMacState == MAC_ACK_PENDING)
     {
@@ -1710,7 +1741,7 @@
           m_phy->PlmeSetTRXStateRequest (IEEE_802_15_4_PHY_TRX_OFF);
         }
 
-      CheckQueue ();
+
     }
   else if (macState == MAC_ACK_PENDING)
     {
@@ -1805,7 +1836,7 @@
 void
 LrWpanMac::PrintTransmitQueueSize (void)
 {
-  NS_LOG_DEBUG("Transit Queue Size: "<<m_txQueue.size());
+  NS_LOG_DEBUG ("Transmit Queue Size: " << m_txQueue.size ());
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lr-wpan/model/lr-wpan-mac.h ns-3.34/src/lr-wpan/model/lr-wpan-mac.h
--- ns-3.33/src/lr-wpan/model/lr-wpan-mac.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lr-wpan/model/lr-wpan-mac.h	2021-07-14 10:31:06.000000000 -0700
@@ -1058,8 +1058,10 @@
    * After a successful transmission of a frame (beacon, data) or an ack frame reception,
    * the mac layer wait an Interframe Space (IFS) time and triggers this function
    * to continue with the MAC flow.
+   *
+   * \param ifsTime IFS time
    */
-  void IfsWaitTimeout (void);
+  void IfsWaitTimeout (Time ifsTime);
   /**
    * Check for remaining retransmissions for the packet currently being sent.
    * Drop the packet, if there are no retransmissions left.
@@ -1076,20 +1078,30 @@
   /**
    * Constructs a Superframe specification field from the local information,
    * the superframe Specification field is necessary to create a beacon frame.
+   *
+   * \returns the Superframe specification field
    */
   SuperframeField GetSuperframeField (void);
   /**
-   * Constructs the Guaranteed Time Slots (GTS) Fields from local information
+   * Constructs the Guaranteed Time Slots (GTS) Fields from local information.
    * The GTS Fields are part of the beacon frame.
+   *
+   * \returns the Guaranteed Time Slots (GTS) Fields
    */
   GtsFields GetGtsFields (void);
   /**
-    * Constructs Pending Address Fields from the local information,
-    * the Pending Address Fields are part of the beacon frame.
-    */
+   * Constructs Pending Address Fields from the local information,
+   * the Pending Address Fields are part of the beacon frame.
+   *
+   * \returns the Pending Address Fields
+   */
   PendingAddrFields GetPendingAddrFields (void);
 
   /**
+   * The trace source is fired at the end of any Interframe Space (IFS).
+   */
+  TracedCallback<Time> m_macIfsEndTrace;
+  /**
    * The trace source fired when packets are considered as successfully sent
    * or the transmission has been given up.
    * Only non-broadcast packets are traced.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lr-wpan/model/lr-wpan-mac-pl-headers.h ns-3.34/src/lr-wpan/model/lr-wpan-mac-pl-headers.h
--- ns-3.33/src/lr-wpan/model/lr-wpan-mac-pl-headers.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lr-wpan/model/lr-wpan-mac-pl-headers.h	2021-07-14 10:31:06.000000000 -0700
@@ -76,7 +76,7 @@
    * \return The GTS fields.
    */
   GtsFields GetGtsFields (void) const;
-  /***
+  /**
    * Get the pending address fields from the beacon payload header.
    * \return The Pending Address fields.
    */
@@ -146,10 +146,12 @@
 
   /**
    * Set the command frame type
+   * \param macCmd the command frame type
    */
-  void SetCommandFrameType (MacCommand  macCmd);
+  void SetCommandFrameType (MacCommand macCmd);
   /**
    * Get the command frame type
+   * \return the command frame type
    */
   MacCommand GetCommandFrameType (void) const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lr-wpan/model/lr-wpan-net-device.h ns-3.34/src/lr-wpan/model/lr-wpan-net-device.h
--- ns-3.33/src/lr-wpan/model/lr-wpan-net-device.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lr-wpan/model/lr-wpan-net-device.h	2021-07-14 10:31:06.000000000 -0700
@@ -215,7 +215,7 @@
    * As a consequence, here we set it to 1.
    *
    * \param panId The PanID
-   * \param shortMac The Short MAC address
+   * \param shortAddr The Short MAC address
    * \return a Pseudo-Mac48Adress
    */
   Mac48Address BuildPseudoMacAddress (uint16_t panId, Mac16Address shortAddr) const;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lr-wpan/model/lr-wpan-phy.cc ns-3.34/src/lr-wpan/model/lr-wpan-phy.cc
--- ns-3.33/src/lr-wpan/model/lr-wpan-phy.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lr-wpan/model/lr-wpan-phy.cc	2021-07-14 10:31:06.000000000 -0700
@@ -146,7 +146,7 @@
   // default -110 dBm in W for 2.4 GHz
   m_rxSensitivity = pow (10.0, -106.58 / 10.0) / 1000.0;
   LrWpanSpectrumValueHelper psdHelper;
-  m_txPsd = psdHelper.CreateTxPowerSpectralDensity (m_phyPIBAttributes.phyTransmitPower,
+  m_txPsd = psdHelper.CreateTxPowerSpectralDensity (GetNominalTxPowerFromPib (m_phyPIBAttributes.phyTransmitPower),
                                                     m_phyPIBAttributes.phyCurrentChannel);
   m_noise = psdHelper.CreateNoisePowerSpectralDensity (m_phyPIBAttributes.phyCurrentChannel);
   m_signal = Create<LrWpanInterferenceHelper> (m_noise->GetSpectrumModel ());
@@ -206,7 +206,7 @@
 
 
 Ptr<MobilityModel>
-LrWpanPhy::GetMobility (void)
+LrWpanPhy::GetMobility (void) const
 {
   NS_LOG_FUNCTION (this);
   return m_mobility;
@@ -260,7 +260,7 @@
 }
 
 Ptr<AntennaModel>
-LrWpanPhy::GetRxAntenna (void)
+LrWpanPhy::GetRxAntenna (void) const
 {
   NS_LOG_FUNCTION (this);
   return m_antenna;
@@ -938,7 +938,8 @@
               }
             m_phyPIBAttributes.phyCurrentChannel = attribute->phyCurrentChannel;
             LrWpanSpectrumValueHelper psdHelper;
-            m_txPsd = psdHelper.CreateTxPowerSpectralDensity (m_phyPIBAttributes.phyTransmitPower, m_phyPIBAttributes.phyCurrentChannel);
+            m_txPsd = psdHelper.CreateTxPowerSpectralDensity (GetNominalTxPowerFromPib (m_phyPIBAttributes.phyTransmitPower),
+                                                                                        m_phyPIBAttributes.phyCurrentChannel);
           }
         break;
       }
@@ -956,15 +957,17 @@
       }
     case phyTransmitPower:
       {
-        if (attribute->phyTransmitPower > 0xbf)
+        if (attribute->phyTransmitPower & 0xC0)
           {
+            NS_LOG_LOGIC ("LrWpanPhy::PlmeSetAttributeRequest error - can not change read-only attribute bits.");
             status = IEEE_802_15_4_PHY_INVALID_PARAMETER;
           }
         else
           {
             m_phyPIBAttributes.phyTransmitPower = attribute->phyTransmitPower;
             LrWpanSpectrumValueHelper psdHelper;
-            m_txPsd = psdHelper.CreateTxPowerSpectralDensity (m_phyPIBAttributes.phyTransmitPower, m_phyPIBAttributes.phyCurrentChannel);
+            m_txPsd = psdHelper.CreateTxPowerSpectralDensity (GetNominalTxPowerFromPib (m_phyPIBAttributes.phyTransmitPower),
+                                                              m_phyPIBAttributes.phyCurrentChannel);
           }
         break;
       }
@@ -1416,6 +1419,29 @@
   return dataSymbolRates [m_phyOption].symbolRate / (dataSymbolRates [m_phyOption].bitRate / 8);
 }
 
+int8_t
+LrWpanPhy::GetNominalTxPowerFromPib (uint8_t phyTransmitPower)
+{
+  NS_LOG_FUNCTION (this << +phyTransmitPower);
+
+  // The nominal Tx power is stored in the PIB as a 6-bit
+  // twos-complement, signed number.
+
+  // The 5 LSBs can be copied - as their representation
+  // is the same for unsigned and signed integers.
+  int8_t nominalTxPower = phyTransmitPower & 0x1F;
+
+  // Now check the 6th LSB (the "sign" bit).
+  // It's a twos-complement format, so the "sign"
+  // bit represents -2^5 = -32.
+  if (phyTransmitPower & 0x20)
+    {
+      nominalTxPower -= 32;
+    }
+  return nominalTxPower;
+}
+
+
 int64_t
 LrWpanPhy::AssignStreams (int64_t stream)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lr-wpan/model/lr-wpan-phy.h ns-3.34/src/lr-wpan/model/lr-wpan-phy.h
--- ns-3.33/src/lr-wpan/model/lr-wpan-phy.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lr-wpan/model/lr-wpan-phy.h	2021-07-14 10:31:06.000000000 -0700
@@ -51,7 +51,7 @@
 {
   double averagePower;    //!< Average measured power
   Time lastUpdate;        //!< Last update time
-  Time measurementLength; //!< Total measuremement period
+  Time measurementLength; //!< Total measurement period
 } LrWpanEdPower;
 
 /**
@@ -158,7 +158,7 @@
 {
   uint8_t phyCurrentChannel;         //!< The RF channel to use
   uint32_t phyChannelsSupported[32]; //!< BitField representing the available channels supported by a channel page.
-  uint8_t phyTransmitPower;          //!< Transmit power
+  uint8_t phyTransmitPower;          //!< 2 MSB: tolerance on the transmit power, 6 LSB: Tx power in dBm relative to 1mW (signed int in 2-complement format)
   uint8_t phyCCAMode;                //!< CCA mode
   uint32_t phyCurrentPage;           //!< Current channel page
   uint32_t phyMaxFrameDuration;      //!< The maximum number of symbols in a frame
@@ -276,7 +276,7 @@
 
   // inherited from SpectrumPhy
   void SetMobility (Ptr<MobilityModel> m);
-  Ptr<MobilityModel> GetMobility (void);
+  Ptr<MobilityModel> GetMobility (void) const;
   void SetChannel (Ptr<SpectrumChannel> c);
 
   /**
@@ -294,7 +294,7 @@
    * \param a the antenna
    */
   void SetAntenna (Ptr<AntennaModel> a);
-  Ptr<AntennaModel> GetRxAntenna (void);
+  Ptr<AntennaModel> GetRxAntenna (void) const;
   virtual Ptr<const SpectrumModel> GetRxSpectrumModel (void) const;
 
   /**
@@ -676,6 +676,24 @@
   TracedCallback<Time, LrWpanPhyEnumeration, LrWpanPhyEnumeration> m_trxStateLogger;
 
   /**
+   * Calculates the nominal transmit power of the device in decibels relative to 1 mW
+   * according to the representation of the PIB attribute phyTransmitPower.
+   *
+   * The phyTransmitPower (table 23 of IEEE 802.15.4-2006) is a 8-bit bitmap, stored
+   * as a `uint8_t`. The bitmap has the following meaning:
+   * The 2 MSBs represent the tolerance on the transmit power.
+   * The 6 LSBs represent a signed integer in twos-complement format, corresponding
+   * to the nominal transmit power of the device in decibels relative to 1 mW.
+   *
+   * This function extracts the 6 LSBs corresponding to the nominal transmit power and
+   * converts it to a `int8_t`.
+   *
+   * \param phyTransmitPower the PIB attribute
+   * \return The nominal transmit power in dBm.
+   */
+  int8_t GetNominalTxPowerFromPib (uint8_t phyTransmitPower);
+
+  /**
    * The mobility model used by the PHY.
    */
   Ptr<MobilityModel> m_mobility;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lr-wpan/test/lr-wpan-ack-test.cc ns-3.34/src/lr-wpan/test/lr-wpan-ack-test.cc
--- ns-3.33/src/lr-wpan/test/lr-wpan-ack-test.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lr-wpan/test/lr-wpan-ack-test.cc	2021-07-14 10:31:06.000000000 -0700
@@ -56,12 +56,15 @@
 {
 public:
 
+  /**
+   * Test modes
+   */
   typedef enum
   {
-    EXTENDED_ADDRESS_UNICAST,
-    SHORT_ADDRESS_UNICAST,
-    SHORT_ADDRESS_MULTICAST,
-    SHORT_ADDRESS_BROADCAST,
+    EXTENDED_ADDRESS_UNICAST,   //!< extended addresses
+    SHORT_ADDRESS_UNICAST,      //!< short addresses, unicast
+    SHORT_ADDRESS_MULTICAST,    //!< short addresses, multicast
+    SHORT_ADDRESS_BROADCAST,    //!< short addresses, broadcast
   } TestMode_e;
 
   /**
@@ -74,27 +77,23 @@
 
   /**
    * \brief Function called when DataIndication is hit on dev0.
-   * \param testCase The TestCase.
    * \param params The MCPS params.
    * \param p the packet.
    */
   void DataIndicationDev0 (McpsDataIndicationParams params, Ptr<Packet> p);
   /**
    * \brief Function called when DataIndication is hit on dev1.
-   * \param testCase The TestCase.
    * \param params The MCPS params.
    * \param p the packet.
    */
   void DataIndicationDev1 (McpsDataIndicationParams params, Ptr<Packet> p);
   /**
    * \brief Function called when DataConfirm is hit on dev0.
-   * \param testCase The TestCase.
    * \param params The MCPS params.
    */
   void DataConfirmDev0 (McpsDataConfirmParams params);
   /**
    * \brief Function called when DataConfirm is hit on dev1.
-   * \param testCase The TestCase.
    * \param params The MCPS params.
    */
   void DataConfirmDev1 (McpsDataConfirmParams params);
@@ -187,6 +186,8 @@
   RngSeedManager::SetSeed (1);
   RngSeedManager::SetRun (6);
 
+  Packet::EnablePrinting ();
+
   // Helper - used to create traces
   LrWpanHelper helper;
   std::string asciiPrefix;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/lr-wpan/test/lr-wpan-ifs-test.cc ns-3.34/src/lr-wpan/test/lr-wpan-ifs-test.cc
--- ns-3.33/src/lr-wpan/test/lr-wpan-ifs-test.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/lr-wpan/test/lr-wpan-ifs-test.cc	2021-07-14 10:31:06.000000000 -0700
@@ -37,6 +37,7 @@
 
 NS_LOG_COMPONENT_DEFINE ("lr-wpan-ifs-test");
 
+
 /**
  * \ingroup lr-wpan-test
  * \ingroup tests
@@ -49,79 +50,147 @@
   LrWpanDataIfsTestCase ();
   virtual ~LrWpanDataIfsTestCase ();
 
-
-
 private:
+  /**
+   * \brief Function called when DataConfirm is hit.
+   * \param testcase pointer to the testcase
+   * \param dev originating NetDevice
+   * \param params the MCPS params
+   */
   static void DataConfirm (LrWpanDataIfsTestCase *testcase,
                            Ptr<LrWpanNetDevice> dev,
                            McpsDataConfirmParams params);
 
-  static void DataReceived (LrWpanDataIfsTestCase *testcase,
-                            Ptr<LrWpanNetDevice> dev,
-                            Ptr<const Packet>);
-
-  static void MacState (LrWpanDataIfsTestCase *testcase,
-                        Ptr<LrWpanNetDevice> dev,
-                        LrWpanMacState oldValue,
-                        LrWpanMacState newValue);
+  /**
+   * \brief Function called when DataReceived is hit.
+   * \param testcase pointer to the testcase
+   * \param dev originating NetDevice
+   * \param p packet
+   */
+  static void DataReceivedDev0 (LrWpanDataIfsTestCase *testcase,
+                                Ptr<LrWpanNetDevice> dev,
+                                Ptr<const Packet> p);
+
+  /**
+   * \brief Function called when PhyDataRxStart is hit.
+   * \param testcase pointer to the testcase
+   * \param dev originating NetDevice
+   * \param p packet
+   */
+  static void PhyDataRxStart (LrWpanDataIfsTestCase *testcase,
+                              Ptr<LrWpanNetDevice> dev,
+                              Ptr<const Packet> p);
+
+  /**
+   * \brief Function called when DataConfirm is hit.
+   * \param testcase pointer to the testcase
+   * \param dev originating NetDevice
+   * \param p packet
+   */
+  static void DataReceivedDev1 (LrWpanDataIfsTestCase *testcase,
+                                Ptr<LrWpanNetDevice> dev,
+                                Ptr<const Packet>);
+
+  /**
+   * \brief Function called when the IFS ends.
+   * \param testcase pointer to the testcase
+   * \param dev originating NetDevice
+   * \param IfsTime the IFS time
+   */
+  static void IfsEnd (LrWpanDataIfsTestCase *testcase,
+                      Ptr<LrWpanNetDevice> dev,
+                      Time IfsTime);
 
 
 
   virtual void DoRun (void);
   Time m_lastTxTime; //!< The time of the last transmitted packet
-  Time m_ackRxTime; //!< The time of the received acknoledgment.
+  Time m_ackRxTime; //!< The time of the received acknowledgment.
   Time m_endIfs; //!< The time where the Interframe Space ended.
+  Time m_phyStartRx; //!< The time the phy start receiving a packet.
 
 
 };
 
 
 LrWpanDataIfsTestCase::LrWpanDataIfsTestCase ()
-  : TestCase ("Lrwpan: IFS with and without ACK")
-{
-
-}
+  : TestCase ("Lrwpan: IFS tests")
+{}
 
 LrWpanDataIfsTestCase::~LrWpanDataIfsTestCase ()
-{
-
-}
+{}
 
 void
 LrWpanDataIfsTestCase::DataConfirm (LrWpanDataIfsTestCase *testcase, Ptr<LrWpanNetDevice> dev, McpsDataConfirmParams params)
 {
-  std::cout << Simulator::Now ().GetSeconds () << " | Dataframe Sent\n";
+  // get the end time of transmission
   testcase->m_lastTxTime = Simulator::Now ();
-
 }
 
 void
-LrWpanDataIfsTestCase::DataReceived (LrWpanDataIfsTestCase *testcase,Ptr<LrWpanNetDevice> dev, Ptr<const Packet> p)
+LrWpanDataIfsTestCase::DataReceivedDev0 (LrWpanDataIfsTestCase *testcase, Ptr<LrWpanNetDevice> dev, Ptr<const Packet> p)
 {
+  // Callback for Data received in the Dev0
   Ptr<Packet> RxPacket = p->Copy ();
   LrWpanMacHeader receivedMacHdr;
   RxPacket->RemoveHeader (receivedMacHdr);
 
-  NS_ASSERT (receivedMacHdr.IsAcknowledgment ());
-  testcase->m_ackRxTime = Simulator::Now ();
+  if (receivedMacHdr.IsAcknowledgment ())
+    {
+      testcase->m_ackRxTime = Simulator::Now ();
+      std::cout << Simulator::Now ().GetSeconds () << " | Dev0 (Node 0) received Acknowledgment.\n";
+    }
+  else if (receivedMacHdr.GetShortDstAddr ().IsBroadcast ())
+    {
+      std::cout << Simulator::Now ().GetSeconds () << " | Dev0 (Node 0) received Broadcast. \n";
+    }
 
-  std::cout << Simulator::Now ().GetSeconds () << " | ACK received\n";
 }
 
 void
-LrWpanDataIfsTestCase::MacState (LrWpanDataIfsTestCase *testcase, Ptr<LrWpanNetDevice> dev,LrWpanMacState oldValue, LrWpanMacState newValue)
+LrWpanDataIfsTestCase::PhyDataRxStart (LrWpanDataIfsTestCase *testcase, Ptr<LrWpanNetDevice> dev, Ptr<const Packet>)
 {
-  // Check the time after the MAC layer go back to IDLE state
-  // (i.e. after the packet has been sent and the IFS is finished)
+  //get the start time the phy in dev 0 ( Node 0) start receiving a frame
+  testcase->m_phyStartRx = Simulator::Now ();
+}
 
-  if (newValue == LrWpanMacState::MAC_IDLE)
+void
+LrWpanDataIfsTestCase::DataReceivedDev1 (LrWpanDataIfsTestCase *testcase, Ptr<LrWpanNetDevice> dev, Ptr<const Packet> p)
+{
+  // Callback for Data received in the Dev1
+  Ptr<Packet> RxPacket = p->Copy ();
+  LrWpanMacHeader receivedMacHdr;
+  RxPacket->RemoveHeader (receivedMacHdr);
+
+  if (receivedMacHdr.GetShortDstAddr ().IsBroadcast ())
     {
-      testcase->m_endIfs = Simulator::Now ();
-      std::cout << Simulator::Now ().GetSeconds () << " | MAC layer is free\n";
+      std::cout << Simulator::Now ().GetSeconds () << " | Dev1 (Node 1) received Broadcast. \n";
+
+      // Bcst received, respond with another bcst
+
+      Ptr<Packet> p0 = Create<Packet> (50);      // 50 bytes of dummy data
+      McpsDataRequestParams params1;
+      params1.m_dstPanId = 0;
+      params1.m_srcAddrMode = SHORT_ADDR;
+      params1.m_dstAddrMode = SHORT_ADDR;
+      params1.m_dstAddr = Mac16Address ("ff:ff");
+      params1.m_msduHandle = 0;
+
+      Simulator::ScheduleNow (&LrWpanMac::McpsDataRequest,
+                              dev->GetMac (), params1,p0);
     }
 
 }
 
+
+void
+LrWpanDataIfsTestCase::IfsEnd (LrWpanDataIfsTestCase *testcase, Ptr<LrWpanNetDevice> dev, Time IfsTime)
+{
+  // take the time of the end of the IFS
+  testcase->m_endIfs = Simulator::Now ();
+}
+
+
 void
 LrWpanDataIfsTestCase::DoRun ()
 {
@@ -133,6 +202,11 @@
   // implemented and its size correspond to the situations described by the standard.
   // For more info see IEEE 802.15.4-2011 Section 5.1.1.3
 
+  LogComponentEnableAll (LOG_PREFIX_TIME);
+  LogComponentEnableAll (LOG_PREFIX_FUNC);
+  LogComponentEnable ("LrWpanPhy", LOG_LEVEL_DEBUG);
+  LogComponentEnable ("LrWpanMac", LOG_LEVEL_DEBUG);
+  LogComponentEnable ("LrWpanCsmaCa", LOG_LEVEL_DEBUG);
 
   // Create 2 nodes, and a NetDevice for each one
   Ptr<Node> n0 = CreateObject <Node> ();
@@ -159,8 +233,10 @@
   n1->AddDevice (dev1);
 
   // Connect to trace files in the MAC layer
-  dev0->GetMac ()->TraceConnectWithoutContext ("MacStateValue", MakeBoundCallback (&LrWpanDataIfsTestCase::MacState, this, dev0));
-  dev0->GetMac ()->TraceConnectWithoutContext ("MacRx", MakeBoundCallback (&LrWpanDataIfsTestCase::DataReceived, this, dev0));
+  dev0->GetMac ()->TraceConnectWithoutContext ("IfsEnd", MakeBoundCallback (&LrWpanDataIfsTestCase::IfsEnd, this, dev0));
+  dev0->GetMac ()->TraceConnectWithoutContext ("MacRx", MakeBoundCallback (&LrWpanDataIfsTestCase::DataReceivedDev0, this, dev0));
+  dev0->GetPhy ()->TraceConnectWithoutContext ("PhyRxBegin", MakeBoundCallback (&LrWpanDataIfsTestCase::PhyDataRxStart, this, dev0));
+  dev1->GetMac ()->TraceConnectWithoutContext ("MacRx", MakeBoundCallback (&LrWpanDataIfsTestCase::DataReceivedDev1, this, dev1));
 
   Ptr<ConstantPositionMobilityModel> sender0Mobility = CreateObject<ConstantPositionMobilityModel> ();
   sender0Mobility->SetPosition (Vector (0,0,0));
@@ -174,6 +250,10 @@
   cb0 = MakeBoundCallback (&LrWpanDataIfsTestCase::DataConfirm, this, dev0);
   dev0->GetMac ()->SetMcpsDataConfirmCallback (cb0);
 
+  McpsDataConfirmCallback cb1;
+  cb1 = MakeBoundCallback (&LrWpanDataIfsTestCase::DataConfirm, this, dev1);
+  dev1->GetMac ()->SetMcpsDataConfirmCallback (cb1);
+
   Ptr<Packet> p0 = Create<Packet> (2);
   McpsDataRequestParams params;
   params.m_dstPanId = 0;
@@ -199,6 +279,7 @@
   // SIFS = 12 symbols (192 Microseconds on a 2.4Ghz O-QPSK PHY)
   ifsSize = m_endIfs - m_lastTxTime;
   NS_TEST_EXPECT_MSG_EQ (ifsSize, Time (MicroSeconds (192)), "Wrong Short InterFrame Space (SIFS) Size after dataframe Tx");
+  std::cout << "----------------------------------\n";
 
   ////////////////////////  LIFS ///////////////////////////
 
@@ -213,9 +294,10 @@
 
   // MPDU = MAC header (11 bytes) + MSDU (6 bytes)+ MAC trailer (2 bytes)  = 19)
   // MPDU (19 bytes) > 18 bytes therefore IFS = LIFS
-  // LIFS = 20 symbols (640 Microseconds on a 2.4Ghz O-QPSK PHY)
+  // LIFS = 40 symbols (640 Microseconds on a 2.4Ghz O-QPSK PHY)
   ifsSize = m_endIfs - m_lastTxTime;
   NS_TEST_EXPECT_MSG_EQ (ifsSize, Time (MicroSeconds (640)), "Wrong Long InterFrame Space (LIFS) Size after dataframe Tx");
+  std::cout << "----------------------------------\n";
 
   //////////////////////// SIFS after ACK //////////////////
 
@@ -233,6 +315,7 @@
   // SIFS = 12 symbols (192 Microseconds on a 2.4Ghz O-QPSK PHY)
   ifsSize = m_endIfs - m_ackRxTime;
   NS_TEST_EXPECT_MSG_EQ (ifsSize, Time (MicroSeconds (192)), "Wrong Short InterFrame Space (SIFS) Size after ACK Rx");
+  std::cout << "----------------------------------\n";
 
   ////////////////////////  LIFS after ACK //////////////////
 
@@ -248,9 +331,40 @@
 
   // MPDU = MAC header (11 bytes) + MSDU (6 bytes)+ MAC trailer (2 bytes)  = 19)
   // MPDU (19 bytes) > 18 bytes therefore IFS = LIFS
-  // LIFS = 20 symbols (640 Microseconds on a 2.4Ghz O-QPSK PHY)
+  // LIFS = 40 symbols (640 Microseconds on a 2.4Ghz O-QPSK PHY)
   ifsSize = m_endIfs - m_ackRxTime;
   NS_TEST_EXPECT_MSG_EQ (ifsSize, Time (MicroSeconds (640)), "Wrong Long InterFrame Space (LIFS) Size after ACK Rx");
+  std::cout << "----------------------------------\n";
+
+  /////////////////////// BCST frame with immediate BCST response //////////////////
+
+  // A packet is broadcasted and the receiving device respond with another broadcast.
+  // The devices are configured to not have any backoff delays in their CSMA/CA.
+  // In most cases, a device receive a packet after its IFS, however in this test,
+  // the receiving device of the reply broadcast will still be in its IFS when the
+  // broadcast is received (i.e. a PHY StartRX () occur before the end of IFS).
+  // This demonstrates that a device can start receiving a frame even during an IFS.
+
+  // Makes the backoff delay period = 0 in the CSMA/CA
+  dev0->GetCsmaCa ()->SetMacMinBE (0);
+  dev1->GetCsmaCa ()->SetMacMinBE (0);
+
+  p0 = Create<Packet> (50);  // 50 bytes of dummy data
+  params.m_dstPanId = 0;
+  params.m_srcAddrMode = SHORT_ADDR;
+  params.m_dstAddrMode = SHORT_ADDR;
+  params.m_dstAddr = Mac16Address ("ff:ff");
+  params.m_msduHandle = 0;
+
+  Simulator::ScheduleWithContext (1, Seconds (0.0),
+                                  &LrWpanMac::McpsDataRequest,
+                                  dev0->GetMac (), params, p0);
+
+  Simulator::Run ();
+
+  NS_TEST_ASSERT_MSG_GT (m_endIfs, m_phyStartRx, "Error, IFS end time should be greater than PHY start Rx time");
+
+  //////////////////////////////////////////////////////////////////////////////////
 
   Simulator::Destroy ();
 
